Index: /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive/3.3/Manager/AuthorizationManager.cs
===================================================================
--- /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive/3.3/Manager/AuthorizationManager.cs	(revision 6742)
+++ /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive/3.3/Manager/AuthorizationManager.cs	(revision 6743)
@@ -33,16 +33,16 @@
     }
 
+    public void AuthorizeForTask(Guid taskId, DT.Permission requiredPermission) {
+      if (ServiceLocator.Instance.AuthenticationManager.IsInRole(HiveRoles.Slave)) return; // slave-users can access all tasks
+
+      Permission permission = ServiceLocator.Instance.HiveDao.GetPermissionForTask(taskId, ServiceLocator.Instance.UserManager.CurrentUserId);
+      if (permission == Permission.NotAllowed || (permission != DT.Convert.ToEntity(requiredPermission) && DT.Convert.ToEntity(requiredPermission) == Permission.Full))
+        throw new SecurityException("Current user is not authorized to access task");
+    }
+
     public void AuthorizeForJob(Guid jobId, DT.Permission requiredPermission) {
-      if (ServiceLocator.Instance.AuthenticationManager.IsInRole(HiveRoles.Slave)) return; // slave-users can access all jobs
-
       Permission permission = ServiceLocator.Instance.HiveDao.GetPermissionForJob(jobId, ServiceLocator.Instance.UserManager.CurrentUserId);
       if (permission == Permission.NotAllowed || (permission != DT.Convert.ToEntity(requiredPermission) && DT.Convert.ToEntity(requiredPermission) == Permission.Full))
-        throw new SecurityException("Current user is not authorized to access job");
-    }
-
-    public void AuthorizeForExperiment(Guid experimentId, DT.Permission requiredPermission) {
-      Permission permission = ServiceLocator.Instance.HiveDao.GetPermissionForExperiment(experimentId, ServiceLocator.Instance.UserManager.CurrentUserId);
-      if (permission == Permission.NotAllowed || (permission != DT.Convert.ToEntity(requiredPermission) && DT.Convert.ToEntity(requiredPermission) == Permission.Full))
-        throw new SecurityException("Current user is not authorized to access experiment");
+        throw new SecurityException("Current user is not authorized to access task");
     }
   }
Index: /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive/3.3/Manager/EventManager.cs
===================================================================
--- /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive/3.3/Manager/EventManager.cs	(revision 6742)
+++ /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive/3.3/Manager/EventManager.cs	(revision 6743)
@@ -29,5 +29,5 @@
 namespace HeuristicLab.Services.Hive {
   /// <summary>
-  /// This class offers methods for cleaning up offline slaves and jobs
+  /// This class offers methods for cleaning up offline slaves and task
   /// </summary>
   public class EventManager : IEventManager {
@@ -45,6 +45,6 @@
       log.Log("EventManager.Cleanup()");
       SetTimeoutSlavesOffline();
-      SetTimeoutJobsWaiting();
-      FinishParentJobs();
+      SetTimeoutTasksWaiting();
+      FinishParentTasks();
       UpdateStatistics();
     }
@@ -72,5 +72,5 @@
 
     /// <summary>
-    /// Searches for slaves which are timed out, puts them and their jobs offline
+    /// Searches for slaves which are timed out, puts them and their task offline
     /// </summary>
     private void SetTimeoutSlavesOffline() {
@@ -79,5 +79,5 @@
         if (!slave.LastHeartbeat.HasValue || (DateTime.Now - slave.LastHeartbeat.Value) > HeuristicLab.Services.Hive.Properties.Settings.Default.SlaveHeartbeatTimeout) {
           slave.SlaveState = DT.SlaveState.Offline;
-          SetJobsWaiting(slave.Id);
+          SetTasksWaiting(slave.Id);
           dao.UpdateSlave(slave);
         }
@@ -86,32 +86,32 @@
 
     /// <summary>
-    /// Looks for parent jobs which have FinishWhenChildJobsFinished and set their state to finished
+    /// Looks for parent tasks which have FinishWhenChildJobsFinished and set their state to finished
     /// </summary>
-    private void FinishParentJobs() {
-      var parentJobsToFinish = dao.GetParentJobs(dao.GetResources(x => true).Select(x => x.Id), 0, true);
-      foreach (var job in parentJobsToFinish) {
-        dao.UpdateJobState(job.Id, TaskState.Finished, null, null, string.Empty);
+    private void FinishParentTasks() {
+      var parentTasksToFinish = dao.GetParentTasks(dao.GetResources(x => true).Select(x => x.Id), 0, true);
+      foreach (var task in parentTasksToFinish) {
+        dao.UpdateTaskState(task.Id, TaskState.Finished, null, null, string.Empty);
       }
     }
 
-    private void SetJobsWaiting(Guid slaveId) {
-      var jobs = dao.GetJobs(x => x.State == TaskState.Calculating).Where(x => x.StateLog.Last().SlaveId == slaveId);
-      foreach (var j in jobs) {
-        DT.Task job = dao.UpdateJobState(j.Id, TaskState.Waiting, slaveId, null, "Slave timed out.");
-        job.Command = null;
-        dao.UpdateJob(job);
+    private void SetTasksWaiting(Guid slaveId) {
+      var tasks = dao.GetTasks(x => x.State == TaskState.Calculating).Where(x => x.StateLog.Last().SlaveId == slaveId);
+      foreach (var j in tasks) {
+        DT.Task task = dao.UpdateTaskState(j.Id, TaskState.Waiting, slaveId, null, "Slave timed out.");
+        task.Command = null;
+        dao.UpdateTask(task);
       }
     }
 
     /// <summary>
-    /// Looks for jobs which have not sent heartbeats for some time and reschedules them for calculation
+    /// Looks for task which have not sent heartbeats for some time and reschedules them for calculation
     /// </summary>
-    private void SetTimeoutJobsWaiting() {
-      var jobs = dao.GetJobs(x => (x.State == TaskState.Calculating && (DateTime.Now - x.LastHeartbeat) > HeuristicLab.Services.Hive.Properties.Settings.Default.CalculatingJobHeartbeatTimeout)
+    private void SetTimeoutTasksWaiting() {
+      var tasks = dao.GetTasks(x => (x.State == TaskState.Calculating && (DateTime.Now - x.LastHeartbeat) > HeuristicLab.Services.Hive.Properties.Settings.Default.CalculatingJobHeartbeatTimeout)
                                || (x.State == TaskState.Transferring && (DateTime.Now - x.LastHeartbeat) > HeuristicLab.Services.Hive.Properties.Settings.Default.TransferringJobHeartbeatTimeout));
-      foreach (var j in jobs) {
-        DT.Task job = dao.UpdateJobState(j.Id, TaskState.Waiting, null, null, "Slave timed out.");
-        job.Command = null;
-        dao.UpdateJob(job);
+      foreach (var j in tasks) {
+        DT.Task task = dao.UpdateTaskState(j.Id, TaskState.Waiting, null, null, "Slave timed out.");
+        task.Command = null;
+        dao.UpdateTask(task);
       }
     }
Index: /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive/3.3/Manager/HeartbeatManager.cs
===================================================================
--- /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive/3.3/Manager/HeartbeatManager.cs	(revision 6742)
+++ /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive/3.3/Manager/HeartbeatManager.cs	(revision 6743)
@@ -54,10 +54,10 @@
         dao.UpdateSlave(slave);
 
-        // update job data
-        actions.AddRange(UpdateJobs(heartbeat, slave.IsAllowedToCalculate));
+        // update task data
+        actions.AddRange(UpdateTasks(heartbeat, slave.IsAllowedToCalculate));
 
-        // assign new job
+        // assign new task
         if (heartbeat.AssignJob && slave.IsAllowedToCalculate && heartbeat.FreeCores > 0) {
-          var availableJobs = dao.GetWaitingJobs(slave, 1);
+          var availableJobs = dao.GetWaitingTasks(slave, 1);
           if (availableJobs.Count() > 0) {
             var job = availableJobs.First();
@@ -71,21 +71,21 @@
 
     // returns true if assignment was successful
-    private bool AssignJob(Slave slave, Task job) {
-      // load job again and check if it is still available (this is an attempt to reduce the race condition which causes multiple heartbeats to get the same job assigned)
-      if (dao.GetJob(job.Id).State != TaskState.Waiting) return false;
+    private bool AssignJob(Slave slave, Task task) {
+      // load task again and check if it is still available (this is an attempt to reduce the race condition which causes multiple heartbeats to get the same task assigned)
+      if (dao.GetTask(task.Id).State != TaskState.Waiting) return false;
 
-      job = dao.UpdateJobState(job.Id, DataAccess.TaskState.Transferring, slave.Id, null, null);
+      task = dao.UpdateTaskState(task.Id, DataAccess.TaskState.Transferring, slave.Id, null, null);
 
-      // from now on the job has some time to send the next heartbeat (ApplicationConstants.TransferringJobHeartbeatTimeout)
-      job.LastHeartbeat = DateTime.Now;
-      dao.UpdateJob(job);
+      // from now on the task has some time to send the next heartbeat (ApplicationConstants.TransferringJobHeartbeatTimeout)
+      task.LastHeartbeat = DateTime.Now;
+      dao.UpdateTask(task);
       return true;
     }
 
     /// <summary>
-    /// Update the progress of each job
-    /// Checks if all the jobs sent by heartbeat are supposed to be calculated by this slave
+    /// Update the progress of each task
+    /// Checks if all the task sent by heartbeat are supposed to be calculated by this slave
     /// </summary>
-    private IEnumerable<MessageContainer> UpdateJobs(Heartbeat heartbeat, bool IsAllowedToCalculate) {
+    private IEnumerable<MessageContainer> UpdateTasks(Heartbeat heartbeat, bool IsAllowedToCalculate) {
       List<MessageContainer> actions = new List<MessageContainer>();
 
@@ -98,7 +98,7 @@
         // process the jobProgresses
         foreach (var jobProgress in heartbeat.JobProgress) {
-          Task curJob = dao.GetJob(jobProgress.Key);
+          Task curJob = dao.GetTask(jobProgress.Key);
           if (curJob == null) {
-            // job does not exist in db
+            // task does not exist in db
             actions.Add(new MessageContainer(MessageContainer.MessageType.AbortTask, jobProgress.Key));
             DA.LogFactory.GetLogger(this.GetType().Namespace).Log("Job does not exist in DB: " + jobProgress.Key);
@@ -108,9 +108,9 @@
               actions.Add(new MessageContainer(MessageContainer.MessageType.AbortTask, curJob.Id));
               DA.LogFactory.GetLogger(this.GetType().Namespace).Log("The slave " + heartbeat.SlaveId + " is not supposed to calculate Job: " + curJob);
-            } else if (!JobIsAllowedToBeCalculatedBySlave(heartbeat.SlaveId, curJob)) {
-              // assigned resources ids of job do not match with slaveId (and parent resourceGroupIds); this might happen when slave is moved to different group
+            } else if (!TaskIsAllowedToBeCalculatedBySlave(heartbeat.SlaveId, curJob)) {
+              // assigned resources ids of task do not match with slaveId (and parent resourceGroupIds); this might happen when slave is moved to different group
               actions.Add(new MessageContainer(MessageContainer.MessageType.PauseTask, curJob.Id));
             } else {
-              // save job execution time
+              // save task execution time
               curJob.ExecutionTime = jobProgress.Value;
               curJob.LastHeartbeat = DateTime.Now;
@@ -127,5 +127,5 @@
                   break;
               }
-              dao.UpdateJob(curJob);
+              dao.UpdateTask(curJob);
             }
           }
@@ -135,6 +135,6 @@
     }
 
-    private bool JobIsAllowedToBeCalculatedBySlave(Guid slaveId, Task curJob) {
-      var assignedResourceIds = dao.GetAssignedResources(curJob.Id).Select(x => x.Id);
+    private bool TaskIsAllowedToBeCalculatedBySlave(Guid slaveId, Task curTask) {
+      var assignedResourceIds = dao.GetAssignedResources(curTask.Id).Select(x => x.Id);
       var slaveResourceIds = dao.GetParentResources(slaveId).Select(x => x.Id);
       return assignedResourceIds.Any(x => slaveResourceIds.Contains(x));
Index: /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive/3.3/MessageContainer.cs
===================================================================
--- /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive/3.3/MessageContainer.cs	(revision 6742)
+++ /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive/3.3/MessageContainer.cs	(revision 6743)
@@ -37,15 +37,15 @@
     public enum MessageType {
       // *** commands from hive server ***
-      CalculateTask, // slave should calculate a job. the job is already assigned to the slave
-      StopTask,   // slave should stop the job and submit results
+      CalculateTask, // slave should calculate a task. the task is already assigned to the slave
+      StopTask,   // slave should stop the task and submit results
       StopAll,   // stop all and submit results
-      AbortTask,  // slave should shut the job down immediately without submitting results
-      AbortAll,  // slave should abort all jobs immediately
-      PauseTask,  // pause the job and submit the results   
-      PauseAll,  // pause all jobs and submit results
+      AbortTask,  // slave should shut the task down immediately without submitting results
+      AbortAll,  // slave should abort all task immediately
+      PauseTask,  // pause the task and submit the results   
+      PauseAll,  // pause all task and submit results
       Restart,   // restart operation after Sleep
       Sleep,     // disconnect from server, but don't shutdown
       ShutdownSlave,  // slave should shutdown immediately without submitting results
-      SayHello,  // Slave should say hello, because he is unknown to the server
+      SayHello,  // Slave should say hello, because job is unknown to the server
     };
 
Index: /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive/3.3/ServiceContracts/IHiveService.cs
===================================================================
--- /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive/3.3/ServiceContracts/IHiveService.cs	(revision 6742)
+++ /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive/3.3/ServiceContracts/IHiveService.cs	(revision 6743)
@@ -33,84 +33,84 @@
     #region Task Methods
     [OperationContract]
-    Guid AddJob(Task job, TaskData jobData, IEnumerable<Guid> resourceIds);
-
-    [OperationContract]
-    Guid AddChildJob(Guid parentJobId, Task job, TaskData jobData);
-
-    [OperationContract]
-    Task GetJob(Guid jobId);
-
-    [OperationContract]
-    IEnumerable<Task> GetJobs();
-
-    [OperationContract]
-    IEnumerable<LightweightTask> GetLightweightJobs(IEnumerable<Guid> jobIds);
-
-    [OperationContract]
-    IEnumerable<LightweightTask> GetLightweightChildJobs(Guid? parentJobId, bool recursive, bool includeParent);
-
-    [OperationContract]
-    IEnumerable<LightweightTask> GetLightweightExperimentJobs(Guid experimentId);
-
-    [OperationContract]
-    TaskData GetJobData(Guid jobId);
-
-    [OperationContract]
-    void UpdateJob(Task jobDto);
-
-    [OperationContract]
-    void UpdateJobData(Task jobDto, TaskData jobDataDto);
-
-    [OperationContract]
-    void DeleteJob(Guid jobId);
-
-    [OperationContract]
-    void DeleteChildJobs(Guid parentJobId);
-
-    [OperationContract]
-    Task UpdateJobState(Guid jobId, TaskState jobState, Guid? slaveId, Guid? userId, string exception);
-    #endregion
-
-    #region Job Control Methods
-    [OperationContract]
-    void StopJob(Guid jobId);
-
-    [OperationContract]
-    void PauseJob(Guid jobId);
-
-    [OperationContract]
-    void RestartJob(Guid jobId);
+    Guid AddTask(Task task, TaskData taskData, IEnumerable<Guid> resourceIds);
+
+    [OperationContract]
+    Guid AddChildTask(Guid parentTaskId, Task task, TaskData taskData);
+
+    [OperationContract]
+    Task GetTask(Guid taskId);
+
+    [OperationContract]
+    IEnumerable<Task> GetTasks();
+
+    [OperationContract]
+    IEnumerable<LightweightTask> GetLightweightTasks(IEnumerable<Guid> taskIds);
+
+    [OperationContract]
+    IEnumerable<LightweightTask> GetLightweightChildTasks(Guid? parentTaskId, bool recursive, bool includeParent);
+
+    [OperationContract]
+    IEnumerable<LightweightTask> GetLightweightJobTasks(Guid jobId);
+
+    [OperationContract]
+    TaskData GetTaskData(Guid taskId);
+
+    [OperationContract]
+    void UpdateTask(Task taskDto);
+
+    [OperationContract]
+    void UpdateTaskData(Task taskDto, TaskData taskDataDto);
+
+    [OperationContract]
+    void DeleteTask(Guid taskId);
+
+    [OperationContract]
+    void DeleteChildTasks(Guid parentTaskId);
+
+    [OperationContract]
+    Task UpdateTaskState(Guid taskId, TaskState taskState, Guid? slaveId, Guid? userId, string exception);
+    #endregion
+
+    #region Task Control Methods
+    [OperationContract]
+    void StopTask(Guid taskId);
+
+    [OperationContract]
+    void PauseTask(Guid taskId);
+
+    [OperationContract]
+    void RestartTask(Guid taskId);
     #endregion
 
     #region Job Methods
     [OperationContract]
-    Job GetHiveExperiment(Guid id);
+    Job GetJob(Guid id);
 
     /// <summary>
-    /// Returns all experiments for the current user
+    /// Returns all task for the current user
     /// </summary>
     [OperationContract]
-    IEnumerable<Job> GetHiveExperiments();
+    IEnumerable<Job> GetJobs();
 
     /// <summary>
-    /// Returns all experiments in the hive (only for admins)
+    /// Returns all task in the hive (only for admins)
     /// </summary>
     /// <returns></returns>
     [OperationContract]
-    IEnumerable<Job> GetAllHiveExperiments();
-
-    [OperationContract]
-    Guid AddHiveExperiment(Job hiveExperimentDto);
-
-    [OperationContract]
-    void UpdateHiveExperiment(Job hiveExperimentDto);
-
-    [OperationContract]
-    void DeleteHiveExperiment(Guid hiveExperimentId);
-    #endregion
-
-    #region HiveExperimentPermission Methods
-    [OperationContract]
-    void GrantPermission(Guid hiveExperimentId, Guid grantedUserId, Permission permission);
+    IEnumerable<Job> GetAllJobs();
+
+    [OperationContract]
+    Guid AddJob(Job jobDto);
+
+    [OperationContract]
+    void UpdateJob(Job jobDto);
+
+    [OperationContract]
+    void DeleteJob(Guid JobId);
+    #endregion
+
+    #region JobPermission Methods
+    [OperationContract]
+    void GrantPermission(Guid jobId, Guid grantedUserId, Permission permission);
 
     [OperationContract]
@@ -118,8 +118,8 @@
 
     [OperationContract]
-    IEnumerable<JobPermission> GetHiveExperimentPermissions(Guid hiveExperimentId);
-
-    [OperationContract]
-    bool IsAllowedPrivileged(); // current user may execute privileged jobs
+    IEnumerable<JobPermission> GetJobPermissions(Guid jobId);
+
+    [OperationContract]
+    bool IsAllowedPrivileged(); // current user may execute privileged task
     #endregion
 
@@ -140,13 +140,18 @@
     [OperationContract]
     Plugin GetPlugin(Guid pluginId);
+
     [OperationContract]
     Plugin GetPluginByHash(byte[] hash);
+
     [OperationContract]
     [FaultContract(typeof(PluginAlreadyExistsFault))]
     Guid AddPlugin(Plugin plugin, List<PluginData> pluginData);
+
     [OperationContract]
     IEnumerable<Plugin> GetPlugins();
+
     [OperationContract]
     IEnumerable<PluginData> GetPluginDatas(List<Guid> pluginIds);
+
     [OperationContract]
     void DeletePlugin(Guid pluginId);
@@ -194,5 +199,5 @@
 
     [OperationContract]
-    IEnumerable<Task> GetJobsByResourceId(Guid resourceId);
+    IEnumerable<Task> GetTasksByResourceId(Guid resourceId);
 
     [OperationContract]
